//
// Software License for AMDiS
//
// Copyright (c) 2010 Dresden University of Technology 
// All rights reserved.
// Authors: Simon Vey, Thomas Witkowski et al.
//
// This file is part of AMDiS
//
// See also license.opensource.txt in the distribution.


#include "BoundaryElementLevelSetDist.h"

int 
BoundaryElementLevelSetDist::calcDistOnBoundaryElement(
                             ElInfo *elInfo,
			     FixVec<double, VERTEX> &dVec)
{
  // Get intersection information.
  int  elStatus = elLS->createElementLevelSet(elInfo);
  if (elStatus != ElementLevelSet::LEVEL_SET_BOUNDARY)
    return elStatus;
  
  const double  *elVertLevelSetVec = elLS->getElVertLevelSetVec();
  
  // Set distance to values of level set function in element vertices.
  for (int i=0; i<=dim; ++i) {
    dVec[i] = fabs(elVertLevelSetVec[i]);
  }
  
  return elStatus;
}
